/*
 | TS.H
 |
 | Global public definitions for SieFuzzy.
 |
 | Copyright (c) Siemens AG 1993.
 | All rights reserved.
 |
 | $Header:   P:/VCS/TS/TS.H_V   1.1   10 Dec 1993 18:29:36   ror  $
 */

/*
 * Structure to support third party SieFuzzy utilities.
 */
typedef struct
{
    LPSTR lpszCommandLine;      /* Optional command line parameters for utility. */
    LPSTR lpszFileName;         /* Optional filename for utility to process. */
    HGLOBAL hObjProject;        /* The handle to the FPL project. */
    HWND hWndFrame;             /* The frame window of SieFuzzy. */
    HINSTANCE hInst;            /* The instance of SieFuzzy. */
} TSUTILITY;
typedef TSUTILITY FAR *LPTSUTILITY;

/*
 * SieFuzzy API Window Messages.
 */

#define TSM_OK				(WM_USER+1)
#define TSM_CANCEL			(WM_USER+2)
#define TSM_CLOSE			(WM_USER+3)
#define TSM_VERIFY			(WM_USER+4)
#define TSM_INFO			(WM_USER+5)
#define TSM_SETMODE			(WM_USER+6)
#define TSM_UPDATE			(WM_USER+7)
#define TSM_DIRTY			(WM_USER+8)
#define TSM_CREATELAYOUT		(WM_USER+9)
#define TSM_SAVECHANGES 		(WM_USER+10)
#define TSM_PRINT			(WM_USER+11)
#define TSM_PASTE			(WM_USER+12)
#define TSM_SETTOOLS			(WM_USER+13)
#define TSM_CLOSEALL			(WM_USER+14)
#define TSM_SETMENU			(WM_USER+15)
#define TSM_SETTARGET			(WM_USER+16)
#define TSM_FONTCHANGE			(WM_USER+17)
#define TSM_OBJDEAD			(WM_USER+18)
#define TSM_PAINTDELTA			(WM_USER+19)
#define TSM_MENUCHANGE			(WM_USER+20)
#define TSM_UPDATEVALUES		(WM_USER+21)
#define TSM_UPDATEOBJ			(WM_USER+22)
#define TSM_GETCLASS			(WM_USER+23)
#define TSM_CONTEXTCREATE		(WM_USER+24)
#define TSM_CONTEXTDESTROY		(WM_USER+25)
#define TSM_REMTXSET			(WM_USER+26)
#define TSM_EDITFILE			(WM_USER+27)
#define TSM_QUITPEEKLOOP		(WM_USER+28)
#define TSM_MODERESET			(WM_USER+29)
#define TSM_OBJCHANGED			(WM_USER+30)
#define TSM_STRUCTMODS			(WM_USER+31)
#define TSM_FILEOPENED			(WM_USER+32)
#define TSM_CLOSEPROJECT		(WM_USER+33)
#define TSM_NEWPROJECT			(WM_USER+34)
#define TSM_GETPROJECT			(WM_USER+35)
#define TSM_RESTRICT			(WM_USER+36)
#define TSM_NAMECHANGE			(WM_USER+37)
#define TSM_SIMSETMENU			(WM_USER+38)
#define TSM_DOCAPTURE			(WM_USER+39)
#define TSM_OPENCHILD			(WM_USER+40)
#define TSM_CAPTURE                     (WM_USER+41)
#define TSM_OTHERDEAD                   (WM_USER+42)

/*
 * Base id of window specific messages.
 */

#define TSM_USER			(WM_USER+512)



/*
 |  Message indicates that an FPL object or an OTHER are about to be
 |  deleted from the transmission set.
 |    wParam : handle to FPL object or name of OTHER that is being deleted
 |    lParam : TRUE means wParam is an object handle
 |	       FALSE means wParam is a string handle to the OTHER's name
 */
